--[[
Filename: petbattlehud.lua
Author  : Smashed - Bladefist
]]--
RFCC="|cffff2020"; WFCC="|cffffffff";
DFCC="|cff888888"; NFCC="|cffffd200";
PFCC="|cffA335EE"; GFCC="|cff1EFF00";
BFCC="|cff0070ff"; LFCC="|cff9D9D9D";
YFCC="|cffffff00"; OFCC="|cffFF8000";
TFCC="|cffE6CC80"; VFCC="|cffE19a33";
------------------------------------------------------------------------
function PBHUD_Print(a) if(DEFAULT_CHAT_FRAME==nil) then print(RFCC.."PBHUD >> "..YFCC..tostring(a)); else DEFAULT_CHAT_FRAME:AddMessage(RFCC.."PBHUD >> "..YFCC..tostring(a)); end end
------------------------------------------------------------------------
function PBHUD_ResetLog() PBHUD_db.LOG=nil; PBHUD_db.LOGLINE=1; end
------------------------------------------------------------------------
function PBHUD_SetTitle() PBHUDTitleText:SetText(PBHUD_Version.." by "..PBHUD_Author); end
------------------------------------------------------------------------
function PBHUD_DPrint(a)
	a=tostring(GetTime()..">"..a);
	if(PBHUD_db~=nil) then	
		-- if(PBHUD_db.LOG==nil) then PBHUD_db.LOG={}; PBHUD_db.LOGLINE=1; end PBHUD_db.LOG[PBHUD_db.LOGLINE]=a; PBHUD_db.LOGLINE=PBHUD_db.LOGLINE+1;
		for i = 1,10 do local name, fontSize, r, g, b, alpha, shown, locked, docked, uninteractable = GetChatWindowInfo(i);
			if(name~=nil) then if(name=="PBHUD") then PBHUD_db.PBHUD_ChatFrame=getglobal("ChatFrame"..i); end end end
		if(PBHUD_db.PBHUD_ChatFrame==nil) then PBHUD_db.PBHUD_ChatFrame=DEFAULT_CHAT_FRAME; end
				if(PBHUD_db.Debug==true) then if(PBHUD_db.PBHUD_ChatFrame['AddMessage']~=nil)
				then PBHUD_db.PBHUD_ChatFrame:AddMessage(RFCC.."PBHUD_DEBUG>> "..YFCC..a);
				else DEFAULT_CHAT_FRAME:AddMessage(RFCC.."PBHUD_DEBUG>> "..YFCC..a); end end
	else DEFAULT_CHAT_FRAME:AddMessage(RFCC.."PBHUD_DEBUG>> "..YFCC..a);	end
end
------------------------------------------------------------------------[On Update]
function PBHUD_OnUpdate(self)
	if(PBHUD_db~=nil) then
		if(PBHUD_db.FlashTimer==nil) then  PBHUD_db.FlashTimer=GetTime(); end
		if(PBHUD_db.Initiate_PetsMissing~=nil) then if((GetTime()-PBHUD_db.Initiate_PetsMissing)>5) then PBHUD_db.Initiate_PetsMissing=nil; PBHUD_PetsMissing(); end end
		if((GetTime() - PBHUD_db.FlashTimer) > 1) then
			PBHUD_UpdatePetHUD();	
			PBHUD_db.FlashTimer=GetTime();
			if (PBHUD_db.DColor==nil) then PBHUD_db.DColor=1; end
			if (PBHUD_db.DColor==1) then
				PBHUD_db.DColor=0;
				PBH1DeadIcon:SetVertexColor(1,0,0);
				PBH2DeadIcon:SetVertexColor(1,0,0);
				PBH3DeadIcon:SetVertexColor(1,0,0);
				--PBHUD_Print("RED");
			else
				PBHUD_db.DColor=1;
				PBH1DeadIcon:SetVertexColor(1,1,0);
				PBH2DeadIcon:SetVertexColor(1,1,0);
				PBH3DeadIcon:SetVertexColor(1,1,0);
				--PBHUD_Print("WHITE");
			end
		end
	end
end
------------------------------------------------------------------------[SaveStuff]
function PBHUD_SaveStuff() end
------------------------------------------------------------------------[OnLoad]
function PBHUD_OnLoad(self)
    PBHUD_Version 	= "Pet Battle HUD v"..GetAddOnMetadata("petbattlehud", "Version");
	PBHUD_Author	= GetAddOnMetadata("petbattlehud", "Author");
	SLASH_PBHUD1 = "/petbattlehud"; SLASH_PBHUD2 = "/pbh";
    SlashCmdList["PBHUD"] = function(msg) PBHUD_CommandHandler(msg); end
    self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_LOGOUT");	
	self:RegisterEvent("CHAT_MSG_PET_BATTLE_COMBAT_LOG");
	self:RegisterEvent("PET_BATTLE_OPENING_START");
	self:RegisterEvent("PET_BATTLE_CLOSE");
	self:RegisterEvent("PET_BATTLE_OVER");
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
end
------------------------------------------------------------------------[Events		]
function PBHUD_OnEvent(self, event, ...)
	local argz = {}; argz[0],  argz[1], argz[2], argz[3], argz[4], argz[5], argz[6], argz[7], argz[8], argz[9], argz[10], argz[11], argz[12], argz[13], argz[14], argz[15], argz[16], argz[17], argz[18], argz[19],argz[20], argz[21], argz[22], argz[23], argz[24], argz[25], argz[26], argz[27], argz[28], argz[29] = ...;
	local argztxt=""; for ari=0,29 do		if(argz[ari]~=nil) then argztxt=argztxt.." argz["..ari.."]=["..tostring(argz[ari]).."]"; end if(argz[ari]==nil) then argz[ari]="(nil)"; end	end
    local narg=nil; narg={}; local numarg=0; if(argz[0]~=nil) then for word in string.gmatch(argz[0], "%w+") do narg[numarg]=string.lower(word); if(narg[numarg]=="") then narg[numarg]=nil; numarg=numarg-1; end numarg=numarg+1; end end	
	local otxt=" "; local oti=0; for oti = 0,numarg do if(narg[oti]~=nil) then otxt=otxt.." ("..oti..":"..narg[oti]..")"; end end
------------------------------------------------------------------------[Save Variables]
    if(event=="VARIABLES_LOADED") then
        if( not PBHUD_Profile ) then PBHUD_Profile={}; end
	    if( not PBHUD_Profile[GetRealmName()] ) then PBHUD_Profile[GetRealmName()]={}; end
	    if( not PBHUD_Profile[GetRealmName()][UnitName("player")] ) then PBHUD_Profile[GetRealmName()][UnitName("player")]={}; end
    	if( not PBHUD_db ) then PBHUD_db = PBHUD_Profile[GetRealmName()][UnitName("player")]; end
	    if(PBHUD_db) then
			if(PBHUD_db.Debug==nil) then PBHUD_db.Debug = false; end
			PBHUD_db.rarity={};
			PBHUD_db.rarity[0]={};
			PBHUD_db.rarity[1]={};
			PBHUD_db.rarity[2]={};
			PBHUD_db.rarity[3]={};
			PBHUD_db.rarity[4]={};
			PBHUD_db.rarity[5]={};
			PBHUD_db.rarity[6]={};
			PBHUD_db.rarity[7]={};

			PBHUD_db.rarity[0].name="WTF";
			PBHUD_db.rarity[0].color=RFCC;
			PBHUD_db.rarity[1].name="Poor";
			PBHUD_db.rarity[1].color=LFCC;
			PBHUD_db.rarity[2].name="Common";
			PBHUD_db.rarity[2].color=WFCC;
			PBHUD_db.rarity[3].name="Uncommon";
			PBHUD_db.rarity[3].color=GFCC;
			PBHUD_db.rarity[4].name="Rare";
			PBHUD_db.rarity[4].color=BFCC;
			PBHUD_db.rarity[5].name="Epic";
			PBHUD_db.rarity[5].color=PFCC;
			PBHUD_db.rarity[6].name="Legendary";
			PBHUD_db.rarity[6].color=OFCC;
			PBHUD_db.rarity[7].name="Other";
			PBHUD_db.rarity[7].color=TFCC;

            PBHUD_db["Version"]	= PBHUD_Version;
            PBHUD_db["Name"]	= UnitName("player");
            PBHUD_db["Server"]	= GetRealmName();
            PBHUD_db["Locale"]	= GetLocale();
            PBHUD_db["Race"],
            PBHUD_db["RaceEn"]  = UnitRace("player")
            PBHUD_db["Class"],
            PBHUD_db["ClassEn"] = UnitClass("player");
            PBHUD_db["FactionEn"],
            PBHUD_db["Faction"] = UnitFactionGroup("player");
            PBHUD_db.Enabled    = true;
			if(PBHUD_db.PetTeam == nil) then PBHUD_db.PetTeam = {}; end
            PBHUD_Print(PBHUD_db.Version.." by Smashed (Bladefist - Alliance) loaded. For help type /pbh help");
		end
    end
	------------------------------------------------------------------------
	if (event=="PLAYER_LOGOUT") then PBHUD_SaveStuff(); end
	------------------------------------------------------------------------
	if (event=="CHAT_MSG_PET_BATTLE_COMBAT_LOG") then
		--[[for _, petname in string.gmatch(argz[0], "(.+)|t(.+) is now your active pet.") do
            if(petname~=nil) then
				local petslot=PBHUD_GetPetSlotByName(petname);
			end
		end ]]
		for _, dmg, _, petname in string.gmatch(argz[0], "(.+)dealt (%d+) damage to your (.+)|t(.+) (%(+)(.+).") do
			PBHUD_PetDamage(petname,dmg);
			return
		end

		for _, dmg, _, petname in string.gmatch(argz[0], "(.+)dealt (%d+) damage to your (.+)|t(.+).") do
			PBHUD_PetDamage(petname,dmg);
		end
		for _, heal, _, petname in string.gmatch(argz[0], "(.+)healed (%d+) damage from your (.+)|t(.+).") do					
			PBHUD_PetHeal(petname,heal);
		end	
	end
	------------------------------------------------------------------------	
	if (event=="PET_BATTLE_OPENING_START") then
		PBHUD_db.InCombat=true;
		PBHUD_ResetLog();
	end	
	------------------------------------------------------------------------	
	if (event == "PET_BATTLE_OVER") then PBHUD_db.InCombat=false; end	
	------------------------------------------------------------------------	
	if (event == "PET_BATTLE_CLOSE") then PBHUD_db.Initiate_PetsMissing=GetTime(); PBHUD_db.InCombat=false; end	
	------------------------------------------------------------------------	
	if (event == "COMPANION_LEARNED") then end
	------------------------------------------------------------------------	
	if(event == "ZONE_CHANGED_NEW_AREA") then PBHUD_PetsMissing(); end
	------------------------------------------------------------------------
end
------------------------------------------------------------------------
function PBHUD_PetHeal(petname,heal)
	if(petname==nil) then return; end
	if(heal==nil) then return; end
	local petslot=PBHUD_GetPetSlotByName(petname);
	PBHUD_db.PetTeam[petslot].hp=PBHUD_db.PetTeam[petslot].hp+heal;
	if(PBHUD_db.PetTeam[petslot].hp>PBHUD_db.PetTeam[petslot].maxhp) then
		PBHUD_db.PetTeam[petslot].hp=PBHUD_db.PetTeam[petslot].maxhp;
	end
	PBHUD_UpdatePetHUD();
end
------------------------------------------------------------------------
function PBHUD_PetDamage(petname,dmg)
	if(petname==nil) then return; end
	if(dmg==nil) then return; end
	local petslot=PBHUD_GetPetSlotByName(petname);
	PBHUD_db.PetTeam[petslot].hp=PBHUD_db.PetTeam[petslot].hp-dmg;
	if(PBHUD_db.PetTeam[petslot].hp<0) then
		PBHUD_db.PetTeam[petslot].hp=0;
	end
	PBHUD_UpdatePetHUD();
end
------------------------------------------------------------------------
function PBHUD_GetPetSlotByName(petname)
	for i=1,3 do
		if(string.find(petname,PBHUD_db.PetTeam[i].name)) then
			return i;
		end
	end
	return 0
end
------------------------------------------------------------------------
function PBHUD_PetsMissing(zone)
	local x={};
	local p = C_PetJournal;
	p.ClearSearchFilter();
	local zone=GetZoneText();
	local nopets="";
	for i=1,p.GetNumPets(false) do
		local id,_,_,_,_,_,_,n,_,_,_,d=p.GetPetInfoByIndex(i);
		if string.find(d, zone) and not x[n] then
			if( (string.find(d, "Drop:")) or
				(string.find(d, "Quest:")) or
				(string.find(d, "Vendor:")) ) then
			else
				if id>0 then
					-- print(p.GetBattlePetLink(id));
				else
					PBHUD_DPrint(n.." source:["..d.."]");
					if(nopets~="") then 
					
						nopets=nopets..WFCC..","..OFCC..n;
					else						
						nopets=OFCC..n;							
					end
					for _,season in string.gmatch(d,"(.+)Season: |r(.+)") do
						if(season~=nil) then nopets=nopets..WFCC.."("..RFCC.."SEASON: "..season..WFCC..")"..YFCC; end
					end
					for _,weather in string.gmatch(d,"(.+)Weather: |r(.+)") do
						if (weather~=nil) then nopets=nopets..WFCC.."("..RFCC.."WEATHER: "..weather..WFCC..")"..YFCC; end
					end
					
					x[n]=1;
				end
			end
		end
	end
	if(nopets=="") then 
		PBHUD_Print("You have all the capturable pets from "..zone.."!");
	else
		PBHUD_Print("Capturable pets from "..zone.." you don't have: "..nopets);
	end
end
------------------------------------------------------------------------
function PBHUD_UpdatePetHUD()
	local p=C_PetJournal;

	local PBHUD_arr={};
	PBHUD_arr[1]={};
	PBHUD_arr[2]={};
	PBHUD_arr[3]={};
	
	PBHUD_arr[1].icon   = PBH1Texture;
	PBHUD_arr[1].level	= PBH1LevelText;
	PBHUD_arr[1].dead   = PBH1DeadIcon;
	PBHUD_arr[1].name   = PBH1NameText;
	PBHUD_arr[1].xptext = PBH1XPText;
	PBHUD_arr[1].xpbar  = PBH1XPTexture;
	PBHUD_arr[1].hptext = PBH1HPText;
	PBHUD_arr[1].hpbar  = PBH1HPTexture;
	PBHUD_arr[1].speed  = PBH1SpeedText;
	PBHUD_arr[1].power  = PBH1PowerText;	
	
	PBHUD_arr[2].icon   = PBH2Texture;
	PBHUD_arr[2].level	= PBH2LevelText;
	PBHUD_arr[2].dead   = PBH2DeadIcon;
	PBHUD_arr[2].name   = PBH2NameText;
	PBHUD_arr[2].xptext = PBH2XPText;
	PBHUD_arr[2].xpbar  = PBH2XPTexture;
	PBHUD_arr[2].hptext = PBH2HPText;
	PBHUD_arr[2].hpbar  = PBH2HPTexture;
	PBHUD_arr[2].speed  = PBH2SpeedText;
	PBHUD_arr[2].power  = PBH2PowerText;
	
	PBHUD_arr[3].icon   = PBH3Texture;
	PBHUD_arr[3].level	= PBH3LevelText;
	PBHUD_arr[3].dead   = PBH3DeadIcon;
	PBHUD_arr[3].name   = PBH3NameText;
	PBHUD_arr[3].xptext = PBH3XPText;
	PBHUD_arr[3].xpbar  = PBH3XPTexture;
	PBHUD_arr[3].hptext = PBH3HPText;
	PBHUD_arr[3].hpbar  = PBH3HPTexture;
	PBHUD_arr[3].speed  = PBH3SpeedText;
	PBHUD_arr[3].power  = PBH3PowerText;
	

	for slot = 1,3 do
		local pet = {};
		if(pet~=nil) then
			pet.abilities = {};
			pet.petID, pet.abilities[1], pet.abilities[2], pet.abilities[3] = p.GetPetLoadOutInfo(slot);
			if(pet.petID~=nil) then
				local speciesid, customname, level, xp, maxxp, displayid, name, icon, pettype, creatureid = p.GetPetInfoByPetID(pet.petID);
				local hp , maxhp, power, speed, rarity = p.GetPetStats(pet.petID);
				if(PBHUD_db.PetTeam[slot]==nil) then PBHUD_db.PetTeam[slot]={}; end
				PBHUD_db.PetTeam[slot].petID=pet.petID;
				if(PBHUD_db.InCombat~=true) then
					PBHUD_db.PetTeam[slot].icon=icon;
					PBHUD_db.PetTeam[slot].power=power;
					PBHUD_db.PetTeam[slot].speed=speed;
					PBHUD_db.PetTeam[slot].rarity=rarity;
					PBHUD_db.PetTeam[slot].name=name;
					PBHUD_db.PetTeam[slot].hp=hp;
					PBHUD_db.PetTeam[slot].maxhp=maxhp;
					PBHUD_db.PetTeam[slot].level=level;
					PBHUD_db.PetTeam[slot].xp=xp;
					PBHUD_db.PetTeam[slot].maxxp=maxxp;
				end

				if(speciesid==nil) then speciesid="(nil)"; end
				if(creatureid==nil) then creatureid="(nil)"; end
				
				if(PBHUD_db.PetTeam[slot].name==nil) then PBHUD_db.PetTeam[slot].name="unknown"; end
				
				if(PBHUD_db.PetTeam[slot].icon==nil) then PBHUD_db.PetTeam[slot].icon="(nil)"; end
				if(PBHUD_db.PetTeam[slot].power==nil) then PBHUD_db.PetTeam[slot].power="(nil)"; end
				if(PBHUD_db.PetTeam[slot].speed==nil) then PBHUD_db.PetTeam[slot].speed="(nil)"; end
				if(PBHUD_db.PetTeam[slot].rarity==nil) then PBHUD_db.PetTeam[slot].rarity=1; end
				if(PBHUD_db.PetTeam[slot].hp==nil) then PBHUD_db.PetTeam[slot].hp=1; end
				if(PBHUD_db.PetTeam[slot].maxhp==nil) then PBHUD_db.PetTeam[slot].maxhp=100; end
				if(PBHUD_db.PetTeam[slot].level==nil) then PBHUD_db.PetTeam[slot].level=1; end
				if(PBHUD_db.PetTeam[slot].xp==nil) then PBHUD_db.PetTeam[slot].xp=1; end
				if(PBHUD_db.PetTeam[slot].maxxp==nil) then PBHUD_db.PetTeam[slot].maxxp=100; end
				
				PBHUD_DPrint("slot["..slot..
							"] petID["..PBHUD_db.PetTeam[slot].petID..
							"] name["..PBHUD_db.PetTeam[slot].name..
							"] rarity["..PBHUD_db.PetTeam[slot].rarity..
							"] speed["..PBHUD_db.PetTeam[slot].speed..
							"] power["..PBHUD_db.PetTeam[slot].power..
							"]");


				
				if(PBHUD_db.PetTeam[slot].level==nil) then PBHUD_db.PetTeam[slot].level=0; end
				
				if(PBHUD_db.PetTeam[slot].xp==nil) then PBHUD_db.PetTeam[slot].xp=0; end
				if(PBHUD_db.PetTeam[slot].maxxp==nil) then PBHUD_db.PetTeam[slot].maxxp=100;end				
				PBHUD_db.PetTeam[slot].xp_prct = (PBHUD_db.PetTeam[slot].xp/PBHUD_db.PetTeam[slot].maxxp)*100;				
				if(PBHUD_db.PetTeam[slot].xp_prct>100) then PBHUD_db.PetTeam[slot].xp_prct=100; end
				if(PBHUD_db.PetTeam[slot].xp==0) then PBHUD_db.PetTeam[slot].xp_prct=1; end
				
				if(PBHUD_db.PetTeam[slot].hp==nil) then PBHUD_db.PetTeam[slot].hp=0; end
				if(PBHUD_db.PetTeam[slot].maxhp==nil) then PBHUD_db.PetTeam[slot].maxhp=100; end
				PBHUD_db.PetTeam[slot].hp_prct = (PBHUD_db.PetTeam[slot].hp/PBHUD_db.PetTeam[slot].maxhp)*100;
				if(PBHUD_db.PetTeam[slot].hp_prct>100) then PBHUD_db.PetTeam[slot].hp_prct=100; end			
				if(PBHUD_db.PetTeam[slot].hp==0) then
					if(PBHUD_arr[slot].dead~=nil) then PBHUD_arr[slot].dead:Show(); end
					PBHUD_db.PetTeam[slot].hp_prct=1;
				else
					if(PBHUD_arr[slot].dead~=nil) then PBHUD_arr[slot].dead:Hide(); end
				end
				
				PBHUD_arr[slot].icon:SetTexture(PBHUD_db.PetTeam[slot].icon);
				
				-- PBHUD_db.PetTeam[slot].icon=icon;
				-- PBHUD_db.PetTeam[slot].power=power;
				-- PBHUD_db.PetTeam[slot].speed=speed;
				-- PBHUD_db.PetTeam[slot].rarity=rarity;

				if(tonumber(PBHUD_db.PetTeam[slot].level)<10) then
					if(string.find(PBHUD_db.PetTeam[slot].level," ")) then
					else
						PBHUD_db.PetTeam[slot].level=" "..PBHUD_db.PetTeam[slot].level;
					end
				end
				if(PBHUD_arr[slot].level~=nil) then PBHUD_arr[slot].level:SetText(VFCC..PBHUD_db.PetTeam[slot].level); end
				
				PBHUD_arr[slot].name:SetText(PBHUD_db.rarity[PBHUD_db.PetTeam[slot].rarity].color..tostring(PBHUD_db.PetTeam[slot].name ));
				
				PBHUD_arr[slot].hptext:SetText(tostring(PBHUD_db.PetTeam[slot].hp).."/"..tostring(PBHUD_db.PetTeam[slot].maxhp));
				PBHUD_arr[slot].xptext:SetText(tostring(PBHUD_db.PetTeam[slot].xp).."/"..tostring(PBHUD_db.PetTeam[slot].maxxp));
				PBHUD_arr[slot].xpbar:SetWidth(PBHUD_db.PetTeam[slot].xp_prct);
				PBHUD_arr[slot].hpbar:SetWidth(PBHUD_db.PetTeam[slot].hp_prct);
				
				PBHUD_arr[slot].speed:SetText(PBHUD_db.PetTeam[slot].speed);
				PBHUD_arr[slot].power:SetText(PBHUD_db.PetTeam[slot].power);
			end
		end		
	end
end
------------------------------------------------------------------------
function PBHUD_PetXP(petname)
	local p = C_PetJournal;
end
------------------------------------------------------------------------[Pet Battle HUD HELP]
function PBHUD_ShowHelp(msg)
	PBHUD_Print("------------------------------------------------------------------------");
    PBHUD_Print("Pet Battle HUD by Smashed @ Bladefist / US --- Help:");
	PBHUD_Print("------------------------------------------------------------------------");
    PBHUD_Print("/pbh show.............displays interface");    
	PBHUD_Print("/pbh hide.............hides interface");
	PBHUD_Print("/pbh debug............toggle debugging information");
end
------------------------------------------------------------------------[Handle functions]
function PBHUD_CommandHandler(msg)
    local cmd=msg;
    for mesg,arg2 in string.gmatch(msg, "(.+) (.+)") do msg=mesg; arg1=arg2; end
    narg=nil; narg={};
    if(msg~=nil) then numarg=0;
        for word in string.gmatch(cmd, "%w+") do
            narg[numarg]=word; if(narg[numarg]=="") then narg[numarg]=nil; numarg=numarg-1; end
			if(PBHUD_db.Debug==true) then PBHUD_Print(numarg.." ["..narg[numarg].."]"); end
            numarg=numarg+1;
        end
    end
	----------------------------------------------------------------------
	if(msg=="show") then PBHUD:Show(); end
	----------------------------------------------------------------------
	if(msg=="hide") then PBHUD:Hide(); end
	----------------------------------------------------------------------
	if(msg=="debug") then	
		if(PBHUD_db.Debug==true) then PBHUD_db.Debug=false; PBHUD_Print("Debugging off");
		else	PBHUD_db.Debug=true; PBHUD_Print("Debugging on"); end
	end
	---------------------------------------------------------------------- Print Help
    if (( msg == "help" ) or ( msg == "" ) or ( msg == "?" )) then PBHUD_ShowHelp(); end
end

